# -*- coding: utf-8 -*-
"""
Created on Mon Dec 19 12:55:15 2016

@author: akidribm
"""
from sortal import affineTransform, transformSet
from decimal import Decimal
import timeit
from sympy import pi,cos,sin
  
def transform(form, rotatingAngle):
    angle = rotatingAngle * pi/180 # Creating the transformation matrix for rotating a form by degrees equivalent to rotatingAngle input
    transform1 = affineTransform.rotation(angle) # Get the transformation matrix for rotating by the angle
    transform2 = affineTransform.scale(1/(cos(angle)+sin(angle))) # Get the transformation matrix for scaling 
    transform = transform1.combine(transform2) # Combining the two transformation matrices into a single matrix
    tfs = transformSet() # Make a transformSet for performing transformation on forms
    tfs.add(transform) # Add transformation matrix into the transformSet
    form = form.edit(tfs)
    return form