# -*- coding: utf-8 -*-
"""
Created on Thu Nov 24 10:43:04 2016

@author: akibdpt
"""
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import division
from __future__ import absolute_import
from builtins import super
"""
from future import standard_library
standard_library.install_aliases()
"""
from .singlyForm import singlyForm

class specialForm(singlyForm):
    type = 'form-special'
    
    def __init__(self, sort, *args, **kwargs):
        super(specialForm, self).__init__(sort)

    def printE(self, string = ''):
        print(string, end = '|')
        print(self.sort.name+':')
        if self.individual is not None:
            print(string, end = ' _ ')
            print(self.individual.printVal())
            if self.individual.hasAttribute():
                self.individual.attribute.printE(string+'  ')
        return

    def insert(self, ind):
        if self.sort != ind.sort:
            raise ValueError("not of the same sort")
        
        if 'form' in ind.type:
            if ind.individual is not None:
                self.add(ind.individual)
        else:
            self.add(ind)
        
    def add(self, ind):
        if self.individual is None or self.individual.isNil():
            if ind.assoc is None:
                self.individual = ind
                ind.assoc = self
            else:
                self.individual = ind.duplicateInd()
                self.individual.assoc = self

        elif not self.individual.combine(ind):
            self.remove()
        elif ind.hasAttribute():
            self.individual.attribute.sum(ind.attribute)
        
    def sum(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
        
        if other.individual is not None: 
            if self.individual is None:
                self.add(other.individual)
            elif not self.individual.combine(other.individual):
                self.remove()
            elif self.individual.hasAttribute():
                self.individual.attribute.sum(other.individual.attribute)
        self.maximalize(True)
        return
        
    def difference(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
        
        self.maximalize()
        other.maximalize()
            
        if other.individual is not None and self.individual is not None:
            if self.individual.hasAttribute():
                self.individual.attribute.difference(other.individual.attribute)
            if not self.individual.complement(other.individual):
                self.remove()
        self.maximalize(True)
        return 
        
    def product(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
                       
        if self.individual is None or other.individual is None or not self.individual.common(other.individual):
            self.remove()
        elif self.individual.hasAttribute():
            self.individual.attribute.product(other.individual.attribute)
        self.maximalize(True)
        return
        
    def symdifference(self,other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()

        if other.individual is None:
            return        
        if self.individual is None:
            self.add(other.individual)
            return
        if self.individual.compareValue(other.individual) == -1:
            self.add(other.individual)
        if self.individual.hasAttribute() or other.individual.hasAttribute():
            self.individual.attribute.symdifference(other.individual.attribute)
        self.maximalize(True)
        return 
    """
    partition of two forms
    if other.individual < self.individual: other.individual = 0
    if other.individual > self.individual: self.individual = 0
    return min(self.individual, other.individual)
    find partition of attributes
    """
    def partition(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
        if other.individual is None or self.individual is None:
            return None
        common = self.sort.newForm()
        if self.individual.compareValue(other.individual) == 0:
            common.add(self.individual)
            if self.individual.hasAttribute() and other.individual.hasAttribute():
                common.individual.attribute.product(other.individual.attribute)
                self.individual.attribute.difference(common.individual.attribute)
                other.individual.attribute.difference(common.individual.attribute)
            if not self.individual.hasAttribute():
                self.remove()
            if not other.individual.hasAttribute():
                other.remove()
        elif self.individual.compareValue(other.individual) == 1:
            common.add(other.individual)
            other.remove()
        else:
            common.add(self.individual)
            self.remove()
        return common
        
    """
    check if this form is a part of other form
    if other.individual < self.individual: false
    if other.individual > self.individual: true
    if other.individual = self.individual: depending on attributes
    """
    def partOf(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if not self.sort == other.sort:
            raise ValueError('not of the same sort')
            
        self.maximalize()
        other.maximalize()
        
        if other.individual is None:
            return False
        if self.individual is None:
            return True
        if other.individual.contains(self.individual):
            if self.individual.hasAttribute():
                return self.individual.attribute.partOf(other.individual.attribute)
            return True
        return False
