# -*- coding: utf-8 -*-
"""
Created on Fri Aug 19 10:38:02 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import super
from builtins import str

from .individual import individual


class weight(individual):
            
    MIN = 0
    
    type = 'ind-weight'
    
    def __init__(self, sort = None, w = 0, *args, **kwargs):
        super(weight, self).__init__(sort)
        if w > sort.arguments.value:
            w = sort.arguments.value
        self.value = w
            
    def printVal(self):
        return str(self.value)
        
    def length(self):
        return len(self.value)
        
    def isNil(self):
        return self.value == self.MIN
        
    def equals(self, other):
        return (self.value == other.value)
        
    def compareValue(self, other):
        if self.value > other.value:
            return 1
        elif self.value == other.value:
            return 0
        return -1    
        
    def replicateInd(self):
        return weight(self.sort, self.value)

    def getMinInd(self):
        return weight(self.sort)  
        
    def complement(self, other):
        if self.isNil():
            return False
        if other is None or other.isNil():
            return True
        if self.value <= other.value: 
            self.value = self.MIN
            return False
        return True

    @staticmethod
    def parse(reader, sort):
        try:
            ind = weight(sort, int(reader.value()))
        except:
            ind = weight(sort, float(reader.value()))
        reader.newToken()
        return ind
